<script>
import Layout from "../../layouts/main";
import PageHeader from "../../components/page-header";
import tinymce from "vue-tinymce-editor";
import { pageService } from "../../services";
import { required, numeric, requiredIf, url } from "vuelidate/lib/validators";
import { success_message, get_user, error_message } from "../../Helper/helper";
/**
 * Add-product component
 */
export default {
  components: { Layout, PageHeader, tinymce },
  data() {
    return {
      staticpage: {
        id: "",
        page_name: "",
        page_content: "",
        content_type: "",
        content_link: "",
        identifier: ""
      },
      content_options: [
        {
          text: "Content",
          value: 1,
        },
        {
          text: "Link",
          value: 0,
        }
      ],
      existing_message : "",
      display_in: { customer: "1", partner: "1", driver: "1" },
      plugins: [
        // "advlist autolink link image lists charmap print preview hr anchor pagebreak spellchecker",
        "searchreplace wordcount visualblocks visualchars code fullscreen insertdatetime media nonbreaking",
        "save table contextmenu directionality emoticons template paste textcolor",
      ],
      toolbar:
        "insertfile undo redo | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | l      ink image | print preview media fullpage | forecolor backcolor emoticons",
      options: {
        height: 300,
        style_formats: [
          { title: "Bold text", inline: "b" },
          { title: "Red text", inline: "span", styles: { color: "#ff0000" } },
          { title: "Red header", block: "h1", styles: { color: "#ff0000" } },
          { title: "Example 1", inline: "span", classes: "example1" },
          { title: "Example 2", inline: "span", classes: "example2" },
          { title: "Table styles" },
          { title: "Table row 1", selector: "tr", classes: "tablerow1" },
        ],
      },
    };
  },
  validations: {
    staticpage: {
      page_name: {
        required,
      },
      page_content: {
        required : requiredIf(function(form){
          return this.staticpage.content_type == 1;
        }),
      },
      content_link: {
        required : requiredIf(function(form){
          return this.staticpage.content_type == 0;
        }),
        url
      }
    },
  },
  mounted() {
    this.getContentPageById();
    this.vendor_id = get_user().vendor_id || 40818;
  },
  methods: {
    onCategoryChange(event){
       if(event.target.value == 1 || event.target.value == 2) {
          this.existing_message = "If you change category as Privacy policy or Terms & Conditions Page then it will overwrite existing pages to Other category";
       }
    },
    getContentPageById() {
      pageService
        .getContentPageById({ id: this.$route.params.id })
        .then((response) => {
          const {
            page_name,
            page_content,
            id,
            vendor_id,
            content_type,
            content_link,
            display_in,
            identifier
          } = response.data.result;
          if (display_in && display_in !== "") {
            this.display_in = display_in;
          }
          this.staticpage = {
            page_name,
            page_content,
            id,
            vendor_id,
            content_type,
            content_link,
            identifier
          };
          if (this.staticpage.identifier == 1 || this.staticpage.identifier == 2) {
            this.existing_message = "If you change category as Privacy policy or Terms & Conditions Page then it will overwrite existing pages to Other category";
          }
        });
    },
    generalIt() {
      this.$v.$touch();
      // console.log(this.$v.setting.$invalid);
      if (this.$v.staticpage.$invalid) {
        // console.log("if");
        return;
      } else {
        const fd = new FormData();
        fd.append("id", this.staticpage.id);
        fd.append("page_name", this.staticpage.page_name);
        fd.append("page_content", this.staticpage.page_content);
        fd.append("content_type", this.staticpage.content_type);
        fd.append("content_link", this.staticpage.content_link);
        fd.append("display_in", JSON.stringify(this.display_in));
        fd.append("identifier",this.staticpage.identifier);
        pageService.editContentPage(fd).then((response) => {
          if (response.data.code === 200) {
            success_message(response.data.message);
          } else {
            error_message(response.data.message);
          }
        });
      }
    },
  },
};
</script>

<template>
  <div>
    <b-form @submit.prevent="generalIt">
      <div class="row">
        <div class="col-12">
          <div class="card">
            <div class="card-body">
              <div class="form-group">
                <input
                  id="id"
                  name="id"
                  type="hidden"
                  v-model="staticpage.id"
                  class="form-control"
                />
              </div>
              <div class="row">
                <div class="col-md-6">
                  <div class="form-group">
                    <label class="required">{{
                      trans.trans("__JSON__.Page Name")
                    }}</label>
                    <input
                      id="page_name"
                      v-model="$v.staticpage.page_name.$model"
                      type="text"
                      class="form-control"
                      :placeholder="trans.trans('__JSON__.Page Name')"
                      name="page_name"
                      :class="{ 'is-invalid': $v.staticpage.page_name.$error }"
                    />
                    <div v-if="$v.staticpage.page_name.$error" class="invalid-feedback">
                      <span v-if="!$v.staticpage.page_name.required">{{
                        trans.get("__JSON__.Please Enter Page Name")
                      }}</span>
                    </div>
                  </div>
                </div>
                 <div class="col-sm-6">
                  <div class="form-group mb-0">
                    <label>{{ trans.get("__JSON__.Display In") }}</label>
                  </div>
                  <div
                    class="row vendor-status platform-type mb-0"
                  >
                    <b-form-group>
                      <label class="switch">
                        <input
                          type="checkbox"
                          id="customer"
                          name="customer"
                          v-model="display_in.customer"
                          class="switch-on"
                          true-value="1"
                          false-value="0"
                        />
                        <div class="slider round">
                          <span class="on">{{
                            trans.get("__JSON__.Customer")
                          }}</span>
                          <span class="off">{{
                            trans.get("__JSON__.Customer")
                          }}</span>
                        </div>
                      </label>
                    </b-form-group>
                    <b-form-group class="partner">
                      <label class="switch">
                        <input
                          type="checkbox"
                          id="partner"
                          name="partner"
                          v-model="display_in.partner"
                          class="switch-on"
                          true-value="1"
                          false-value="0"
                        />
                        <div class="slider round">
                          <span class="on">{{
                            trans.get("__JSON__.Partner")
                          }}</span>
                          <span class="off">{{
                            trans.get("__JSON__.Partner")
                          }}</span>
                        </div>
                      </label>
                    </b-form-group>
                    <b-form-group class="driver">
                      <label class="switch">
                        <input
                          type="checkbox"
                          id="driver"
                          name="driver"
                          v-model="display_in.driver"
                          class="switch-on"
                          true-value="1"
                          false-value="0"
                        />
                        <div class="slider round">
                          <span class="on">{{
                            trans.get("__JSON__.Drivers")
                          }}</span>
                          <span class="off">{{
                            trans.get("__JSON__.Drivers")
                          }}</span>
                        </div>
                      </label>
                    </b-form-group>
                  </div>
                </div>
              </div>
              <div class="row">
                <div class="col-sm-2 vendor-status content-type">
                  <b-form-group
                    id="input-group-1"
                    :label="trans.get('__JSON__.Content Type')"
                    label-for="content_type"
                  >
                     <b-form-radio-group
                        id="btn-radios-1"
                        class="check-group"
                        v-model="staticpage.content_type"
                        :options="content_options"
                        buttons
                        name="radios-btn-default"
                      ></b-form-radio-group>
                  </b-form-group>
                </div>
                <div class="col-sm-4" :class="{ 'show': staticpage.content_type != '0' }">
                  <label class="required">{{
                    trans.trans("__JSON__.Content Link")
                  }}</label>
                  <input
                    id="content_link"
                    v-model="$v.staticpage.content_link.$model"
                    type="text"
                    class="form-control"
                    :placeholder="trans.get('__JSON__.https://')"
                    name="content_link"
                    :class="{ 'is-invalid': $v.staticpage.content_link.$error }"
                  />
                  <div v-if="$v.staticpage.content_link.$error" class="invalid-feedback">
                    <span v-if="!$v.staticpage.content_link.required">{{
                      trans.get("__JSON__.Please Enter Content Link")
                    }}</span>
                    <span v-if="!$v.staticpage.content_link.url">{{trans.get('__JSON__.This value should be a valid url')}}.</span>
                  </div>
                </div>
                <div class="col-sm-2">
                  <div class="form-group">
                    <label class="control-label">{{ trans.trans('__JSON__.Category') }}</label>
                    <select
                      class="custom-select"
                      v-model="staticpage.identifier"
                      id="identifier"
                      name="identifier"
                      @change="onCategoryChange($event)"
                    >
                      <option value="1">{{ trans.get('__JSON__.Terms & Condition') }}</option>
                      <option value="2">{{ trans.get('__JSON__.Privacy Policy') }}</option>
                      <option value="3">{{ trans.get('__JSON__.Other') }}</option>
                    </select>
                  </div>
                </div>
                <div class="col-sm-6" v-if="staticpage.identifier == 1 || staticpage.identifier == 2">
                  <span class="text-danger">*{{ existing_message }}</span>
                </div>
              </div>
              <div class="row">
                <div class="col-md-12" :class="{ 'hide': staticpage.content_type != '1'}">
                  <tinymce
                    id="d1"
                    v-model="$v.staticpage.page_content.$model"
                    :plugins="plugins"
                    :toolbar="toolbar"
                    :other_options="options"
                    :class="{ 'is-invalid': $v.staticpage.page_content.$error }"
                  ></tinymce>
                  <div v-if="$v.staticpage.page_content.$error" class="invalid-feedback">
                    <span v-if="!$v.staticpage.page_content.required">{{
                      trans.get("__JSON__.Please Enter Page Content")
                    }}</span>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="mb-2">
          <div class="col-sm-6">
            <button type="submit" class="btn btn-primary mr-1 mt-3">
              Update
            </button>
          </div>
        </div>
      </div>
      <!-- end row -->
    </b-form>
  </div>
</template>
<style scoped>
.notes h5 {
  margin-top: 35px;
}
.content-type .switch{
  width: 80px;
}
.content-type input.switch-on:checked + .slider:before{
  left: 27px;
}
.platform-type {
  padding-left: 12px;
}
.platform-type .switch {
  width: 96px;
  height: 36px;
}
.platform-type .partner {
  padding-left: 20px;
}
.platform-type .driver {
  padding-left: 20px;
}
.platform-type input.switch-on:checked + .slider:before {
  left: 40px;
}
.platform-type .switch .off {
  left: 58%;
}
.hide{
  display: none;
}
.show{
  display: none;
}
</style>
